import { movePoints } from '../utils/helpers';
export class MapElement {
    /**
     * Create a new `MapElement`.
     * @param id A value to set as the ID of the `MapElement`.
     */
    constructor(id) {
        /**
         * A flag indicating if this `MapElement` is currently active.  The active
         * element is styled differently to make it stand out.
         */
        this.active = false;
        /**
         * A flag indicating if this `MapElement` is currently enabled.  An element
         * that is not enabled is not rendered on the Map.
         */
        this.enabled = false;
        /**
         * The identifier for this `MapElement`.
         */
        this.id = -1;
        /**
         * The name of this `MapElement`.
         */
        this.name = 'New Element';
        /**
         * The array of `Coordinate`s that are used to draw this `MapElement`.
         */
        this._coordinates = [];
        this.icons = [];
        this.scale = 1;
        if (id !== undefined) {
            this.id = id;
        }
    }
    /**
     * Move this `MapElement` by a specified amount.
     * @param delta The amount to move
     */
    move(delta) {
        this._coordinates = movePoints(this._coordinates, delta);
    }
}
