import '../stencil.core';
import { Coordinate } from '../utils/coordinate';
import { MapElement } from './map-element';
export declare class MapPoint extends MapElement {
    origin: Coordinate;
    coordinates: Coordinate[];
    render(): JSX.Element | undefined;
    /**
     * An empty function that exists just to satisfy Typescript typings.
     */
    removePoint(): void;
    /**
     * Adds a new point to this `MapElement`.  Since `MapPoint`s represent a
     * single point on a map, calling this function will simply set the current
     * position of the Point.
     * @param c The `Coordinate` that will get added
     * @param index Unused.
     */
    addPoint(c: Coordinate, index?: number): void;
    /**
     * Renders any elements needed to control the editing (moving) of this point.
     */
    renderControls(): undefined;
    /**
     * Moves a point by a given amount.  Since a `MapPoint` only has one point,
     * this function simply moves the origin by the specified amount.
     * @param delta The amount to move the point by
     * @param index Unused
     */
    movePoint(delta: Coordinate, index: number): void;
}
